/***************************************************************************
 *   Copyright (C) 2007 by Mauro Rodrigues				   *
 *   mauro.r@ua.pt							   *
 *                                                                         *
 *   PhUA - Projecto Humanóide da Universidade de Aveiro 07/08		   *
 *	@Sistemas de Tempo-Real 07/08					   *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>

#include <highgui.h>
#include <cv.h>
#include <cxcore.h>
#include <cvaux.h>

#include <cvision.h>
#include <visiondefs.h>

using namespace std;

int GlobalPos;
int device=0;

HSVColour color = {30, 90, 70, 256, 100, 256}; // default values

//void SetCamnode(int pos){	device = pos;}
void SetSmin(int pos){	color.Slow = pos;}
void SetSmax(int pos){	color.Shigh = pos+1;}
void SetVmin(int pos){	color.Vlow = pos;}
void SetVmax(int pos){	color.Vhigh = pos+1;}
void SetHmax(int pos){	color.Hhigh = pos+1;}
void SetHmin(int pos){	color.Hlow = pos;}

int main(int argc, char *argv[])
{
//****************************************************************************************
// Declaração das variaveis
//****************************************************************************************
	FILE *fp;
	char str[50], c='0';
	CVision obj1(640,480,device,IPL_DEPTH_8U,3), obj2;

//****************************************************************************************
// Leitura dos parametros armazenados
//****************************************************************************************
	if((fp = fopen("hsv_param.txt","r")) != NULL)
	{
		fscanf(fp,"HSV Color Detection parameters:\n",str);
		fscanf(fp,"H: %d\t%d\n",&(color.Hlow),&(color.Hhigh));
		fscanf(fp,"S: %d\t%d\n",&(color.Slow),&(color.Shigh));
		fscanf(fp,"V: %d\t%d\n",&(color.Vlow),&(color.Vhigh));
	}
	else
	{
		cout << "Could not open file!" << endl;
		return -1;
	}	

//****************************************************************************************
// Criação das imagens
//****************************************************************************************
	IplImage* pyr = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 3);

	//"PyrDown da Imagem Original";
	IplImage* hsv = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 3);

	//Componentes da imagem HSV
	IplImage* h = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 1);

	IplImage* s = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 1);

	IplImage* v = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 1);

	IplImage *h_filter = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 1);
	IplImage *s_filter = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 1);
	IplImage *v_filter = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 1);

	IplImage* filter = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 1);

	IplImage* final = cvCreateImage(cvSize(obj1.m_pImg->width/2,obj1.m_pImg->height/2), obj1.m_pImg->depth, 3);

//****************************************************************************************
// Criação das janelas e trackbars para ajuste fino
//****************************************************************************************
	cout << "Color calibration\n Press 's' to end program!\n" << endl;
	cvNamedWindow("Pyr",CV_WINDOW_AUTOSIZE);
	cvMoveWindow("Pyr",250,0);
	cvNamedWindow("Color",CV_WINDOW_AUTOSIZE);
	cvMoveWindow("Color",580,0);
	cvNamedWindow("Filter",CV_WINDOW_AUTOSIZE);
	cvMoveWindow("Filter",910,0);
	cvNamedWindow("H",CV_WINDOW_AUTOSIZE);
	cvMoveWindow("H",250,295);
	cvNamedWindow("S",CV_WINDOW_AUTOSIZE);
	cvMoveWindow("S",580,295);
	cvNamedWindow("V",CV_WINDOW_AUTOSIZE);
	cvMoveWindow("V",910,295);
	
	cvCreateTrackbar("SetHmax","H", &color.Hhigh ,255,SetHmax);
	cvCreateTrackbar("SetHmin","H", &color.Hlow ,255,SetHmin);
	cvCreateTrackbar("SetSmax","S", &color.Shigh ,255,SetSmax);
	cvCreateTrackbar("SetSmin","S", &color.Slow ,255,SetSmin);
	cvCreateTrackbar("SetVmax","V", &color.Vhigh ,255,SetVmax);
	cvCreateTrackbar("SetVmin","V", &color.Vlow ,255,SetVmin);

	cvSetTrackbarPos("SetHmax","H",(int)color.Hhigh);
	cvSetTrackbarPos("SetHmin","H",(int)color.Hlow);
	cvSetTrackbarPos("SetSmax","S",(int)color.Shigh);
	cvSetTrackbarPos("SetSmin","S",(int)color.Slow);
	cvSetTrackbarPos("SetVmin","V",(int)color.Vlow);
	cvSetTrackbarPos("SetVmax","V",(int)color.Vhigh);

	while(c != 's')
	{
		obj1.Refresh();

//****************************************************************************************
// Determinação dos filtros a usar para a cor
//****************************************************************************************
		cvZero(pyr);
		cvPyrDown(obj1.m_pImg, pyr, CV_GAUSSIAN_5x5);

		cvShowImage("Pyr", pyr);
		cvZero(hsv);
		cvCvtColor(pyr, hsv, CV_BGR2HSV );

		cvZero(h);cvZero(s);cvZero(v);
		cvSplit(hsv, h, s, v, NULL );
		cvZero(h_filter);
		cvInRangeS(h, cvScalar(color.Hlow), cvScalar(color.Hhigh), h_filter);

		cvShowImage("H", h_filter);
		cvZero(s_filter);
		cvInRangeS(s, cvScalar(color.Slow), cvScalar(color.Shigh), s_filter);

		cvShowImage("S", s_filter);
		cvZero(v_filter);
		cvInRangeS(v, cvScalar(color.Vlow), cvScalar(color.Vhigh), v_filter);	

		cvShowImage("V", v_filter);
		cvZero(filter);
		cvAnd(h_filter, s_filter, filter, v_filter);

		cvShowImage("Filter", filter);
		cvZero(final);
		cvCopy(pyr, final, filter);

		cvShowImage("Color", final);
		cvSaveImage("./final.jpg",final);

//****************************************************************************************
// Termina aplicação ?
//*****************************************************************************************
		c = cvWaitKey(50);
	}
//****************************************************************************************
// Salva parametros de cor
//****************************************************************************************
	fp = fopen("hsv_param.txt","w");
	fprintf(fp,"HSV Color Detection parameters:\n");
	fprintf(fp,"H: %d\t%d\n",color.Hlow,color.Hhigh);
	fprintf(fp,"S: %d\t%d\n",color.Slow,color.Shigh);
	fprintf(fp,"V: %d\t%d\n",color.Vlow,color.Vhigh);
	fclose(fp);
	obj1.CapnSave("./new.jpg");

	cvDestroyAllWindows();

	return EXIT_SUCCESS;
}
